<template>
  <div class="app-container">
    <el-row :gutter="20">
      <!--部门数据-->
      <!-- <el-col :span="4" :xs="24">
        <div class="head-container">
          <el-input v-model="deptName" placeholder="请输入机构名称" clearable size="small" prefix-icon="el-icon-search"
            style="margin-bottom: 20px" />
        </div>
        <div class="tree-container">
          <div style="margin-bottom: 10px;">
            <el-checkbox v-model="queryParams.checkSub" @change="changeCheckBox">关联下级</el-checkbox>
          </div>
          <el-tree :data="deptOptions" :props="defaultProps" :expand-on-click-node="false"
            :filter-node-method="filterNode" ref="tree" node-key="id" :default-expanded-keys="defaultKeys"
            :default-checked-keys="defaultKeys" @node-click="handleNodeClick" />
        </div>
      </el-col> -->

      <!--机构数据-->
      <el-col :span="4" :xs="24">

        <org-tree v-model="queryParams.orgId" @defaultKey="getDefaultKey" @checkChange="checkChange"
          @click="clickTreeNode" businessTree></org-tree>
      </el-col>
      <el-col :span="20" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="区域名称" prop="areaName">
            <el-input v-model="queryParams.areaName" placeholder="请输入区域" clearable @keyup.enter.native="handleQuery" />
          </el-form-item>

          <el-form-item label="标签编号" prop="code">
            <el-input maxlength="50" v-model="queryParams.code" placeholder="请输入标签编号" clearable
              @keyup.enter.native="handleQuery" />
          </el-form-item>


          <el-form-item label="状态" prop="enable">
            <el-select v-model="queryParams.enable" placeholder="请选择状态">
              <el-option v-for="dict in dict.type.plan_status" :key="dict.value" :label="dict.label"
                :value=dict.value></el-option>
            </el-select>
          </el-form-item>



          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
              v-hasPermi="['system:bind:add']">新增</el-button>
          </el-col>

          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table border height="600" size="small" v-loading="loading" :data="bindList"
          @selection-change="handleSelectionChange">

          <el-table-column label="序号" align="center" min-width="50">
            <template v-slot:default="scope">
              <span v-text="getPageIndex(scope.$index)"> </span>
            </template>
          </el-table-column>
          <el-table-column label="机构名称" align="left" prop="orgName" />

          <el-table-column label="区域名称" align="left" prop="areaName" />

          <el-table-column label="NFC点位" align="left" prop="collectionAreaName" />
          <el-table-column label="标签编号" align="left" prop="code" />
          <el-table-column label="标签名称" align="left" prop="labelName" />
          <el-table-column prop="status" label="状态" width="80">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.plan_status" :value="scope.row.enable" />
            </template>
          </el-table-column>

          <el-table-column label="创建时间" align="center" prop="createTime" />
          <el-table-column label="更新时间" align="center" prop="updateTime" />
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                v-hasPermi="['system:bind:edit']">编辑</el-button>
              <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                v-hasPermi="['system:bind:remove']">删除</el-button>
            </template>
          </el-table-column>
        </el-table>
        <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
          @pagination="getList" />
      </el-col>
    </el-row>

    <!-- 添加或修改【请填写功能名称】对话框 -->
    <DialogCom :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="机构名称" prop="orgId">
          <treeselect v-model="form.orgId" :options="deptOptions" :show-count="true" :normalizer="tenantIdnormalizer"
            :props="{ checkStrictly: true, label: 'name' }" placeholder="请选择机构" @select="changeSelectArea" />
        </el-form-item>
        <el-form-item label="区域名称" v-if="form.orgId != null" prop="areaId">
          <el-select mode="multiple" style="width: 100%;" v-model="form.areaId" :popper-append-to-body="false" placeholder="请选择区域名称">
            <el-option v-for="item in roleOptions" :key="item.id" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="NFC点位" v-if="form.orgId != null" prop="checkId">
          <el-select style="width: 100%;" v-model="form.checkId" :popper-append-to-body="false" placeholder="请选择NFC点位名称">
            <el-option v-for="item in checkList" :key="item.id" :label="item.checkName" :value="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="标签编号" prop="code">
          <el-input maxlength="50" v-model="form.code" placeholder="请输入标签" />
        </el-form-item>
        <el-form-item label="标签名称" prop="labelName">
          <el-input v-model="form.labelName" placeholder="请输入标签名称" maxlength="50" />
        </el-form-item>

        <el-form-item label="状态" prop="enable">
          <el-select style="width: 100%" v-model="form.enable" :popper-append-to-body="false" placeholder="请选择状态">
            <el-option v-for="dict in dict.type.plan_status" :key="dict.value" :label="dict.label"
              :value="`${dict.value}`"></el-option>
          </el-select>
        </el-form-item>



      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </DialogCom>
  </div>
</template>

<script>
import tableList from '@/mixins/tableList'
import treeselect from '@riophae/vue-treeselect'
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import { listBind, getBind, delBind, addBind, updateBind } from "@/api/system/bind";
import { getAreaByOrg } from "@/api/system/area";
import { deptTreeSelect,businessTreeSelect } from "@/api/system/public";
import { getCheckByAreaId, getAreaCheckInfoByOrgId } from "@/api/system/check";
import orgTree from "@/components/orgTree";
export default {
  /** 引入基础minxins*/
  mixins: [tableList],
  components: { treeselect, orgTree },
  dicts: ['sys_normal_disable', 'plan_status'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 总条数
      total: 0,
      names: [],
      //搜索tree
      deptName: null,
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 部门树选项
      deptOptions: null,

      // 【请填写功能名称】表格数据
      bindList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        areaId: null,
        enable: null,
        code: null,
        updateId: null,
        orgId: null,
        orgName: null,
        orgPath: null,
        collectionAreaName: null,
        checkId: null,
        checkSub: true
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        areaId: [
          { required: true, message: '请选择区域', trigger: 'blur' },
        ],
        orgId: [
          { required: true, message: '请选择归属部门', trigger: 'blur' },
        ],
        checkId: [
          { required: true, message: '请选择NFC点位名称', trigger: 'blur' }
        ],
        code: [
          { required: true, message: '请输入标签编号', trigger: 'change' }
        ],
        enable: [
          { required: true, message: '请选择状态', trigger: 'blur' }
        ],
        labelName:[
          { required: true, message: '请输入标签名称', trigger: 'change'}
        ]
      },
      checkList: [],
      roleOptions: [],
      defaultKeys: [],
      //是否关联下级
      checked: false,
      defaultProps: {
        children: "children",
        label: "name"
      },
    };
  },
  created() {
    this.getDeptTree();
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  methods: {
    //单选框状态改变
    checkChange(state) {
      this.queryParams.checkSub = state;
      this.handleQuery();
    },
    // 节点单击事件
    clickTreeNode(data) {
      this.queryParams.orgId = data.id;
      this.handleQuery();
    },
    getPageIndex($index) {
      //表格序号
      return (
        (this.queryParams.pageNum - 1) * this.queryParams.pageSize + $index + 1
      );
    },
    closeOptions() {
      this.$refs.fuzzySearch[0].blur()
    },

    /** 下穿状态改变*/
    changeCheckBox() {
      this.getList();
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true;
      return data.name.indexOf(value) !== -1;
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.orgId = data.id;
      this.handleQuery();
    },
    changeSelectArea(val) {
      getAreaByOrg(val).then(response => {
        this.roleOptions = response.data;
        this.form.areaId = null
      })
      getAreaCheckInfoByOrgId(val).then(response => {
        this.form.checkId = null;
        this.checkList = response.data;
      })
    },
    getDefaultKey(key) {
      this.queryParams.orgId = key;
      this.getList();
    },
    // changeSelect(val) {
    //   getCheckByAreaId(val).then(response => {

    //     this.checkList = response.data;
    //   })
    //   getAreaCheckInfoByOrgId(val).then(response=>{
    //     this.checkList = response.data;
    //   })
    // },
    /** 查询【请填写功能名称】列表 */
    getList() {
      this.loading = true;
      listBind(this.queryParams).then(response => {
        this.bindList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getDeptTree() {
      // deptTreeSelect().then(response => {
      //   this.deptOptions = response.data;
      //   this.defaultKeys.push(response.data[0].id);
      //   this.queryParams.orgId = response.data[0].id;
      //   this.handleQuery();
      // });
      businessTreeSelect().then(response=>{
          this.deptOptions = response.data;
          this.defaultKeys.push(response.data[0].id);
           this.queryParams.orgId = response.data[0].id;
           this.handleQuery();
        })
    },
    tenantIdnormalizer(node, instanceId) {
      if (node.children && !node.children.length) {
        delete node.children
      }
      return {
        id: node.id,
        label: node.name,
        children: node.children
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        areaId: null,
        enable: "0",
        code: null,
        createTime: null,
        updateId: null,
        updateBy: null,
        updateTime: null,
        orgId: null,
        orgName: null,
        orgPath: null,
        collectionAreaName: null,
        checkId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.names = selection.map(item => item.code)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      // this.open = true;
      // this.title = "添加";

      getBind('').then(response => {

        this.roleOptions = response.areas;

        this.open = true;
        this.title = "新增";
        this.form.password = this.initPassword;
      });
    },


    /** 修改按钮操作 */
    handleUpdate(row) {

      this.reset();
      const id = row.id || this.ids
      getBind(id).then(response => {

        this.form = response.data;
        this.roleOptions = response.areas;
        this.checkList = response.checks;

        this.open = true;
        this.title = "编辑";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateBind(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addBind(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const names = row.code || this.names;
      this.$modal.confirm('是否确认删除标签编号为"' + names + '"的数据项？').then(function () {
        return delBind(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/bind/export', {
        ...this.queryParams
      }, `bind_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>

<style lang="scss">
.vue-treeselect__menu-container{
  z-index: 3000 !important;
}
</style>
